#!/usr/bin/env python
#
#  Copyright (c) 2004, Sean Reifschneider, tummy.com, ltd.  
#	All Rights Reserved.
#
#  A CGI for allowing users to access their records via the web.
#
#  http://www.tummy.com/radiusContext/
#  ftp://ftp.tummy.com/pub/tummy/radiusContext/

configFileName = '/usr/local/radiusContext/rcweb.conf'

revision = "$Revision: 1.4 $"
rcsid = "$Id: rcweb.cgi,v 1.4 2005/01/01 21:54:17 jafo Exp $"

import cgitb
cgitb.enable()
import string, os, sys, cgi
import pyrad.packet 
from pyrad.client import Client
from pyrad.dictionary import Dictionary


###################################
def expandtemplate(file, **kwargs):
	'''Read the specified file, replace fields in the file which match the keys
	in the kwargs dictionary, surrounded by "%%%", with the resulting
	dictionary data.'''
	fp = open(file, 'r')
	data = fp.read()
	fp.close()
	for key in kwargs.keys():
		data = string.replace(data, '%%%%%%%s%%%%%%' % key, kwargs[key])
	return(data)


#####################
def do_login(config):
	'Show login page'
	print expandtemplate(
			os.path.join(config.get('htmltemplatedir'), 'login.html'))
	sys.exit(0)


#####################################################
def do_loginfailure(config, reason, login, password):
	'Show login failure page'
	print expandtemplate(
			os.path.join(config.get('htmltemplatedir'), 'login-failed.html'),
			REASON = reason, LOGIN = login, PASSWORD = password)
	sys.exit(0)


####################################################
def do_results(config, mode, body, login, password):
	print expandtemplate(
			os.path.join(config.get('htmltemplatedir'), '%s.html' % mode),
			BODY = body, LOGIN = login, PASSWORD = password)
	sys.exit(0)


###################
#  load config file
configData = {}
execfile(configFileName, {}, configData)

#  show login on initial load
print 'Content-type: text/html\n'
form = cgi.FieldStorage()
if ((not form.has_key('login') or not form['login'].value)
		or (not form.has_key('password') or not form['password'].value)):
	do_login(configData)

#  create pyrad dictionary
pyradDict = Dictionary(configData['dictionaryfile'])

#  check login
login = form['login'].value
password = form['password'].value
srv = Client(server = configData['radiusserver'],
		secret = configData['radiussecret'],
		authport = configData['radiusserverauthport'], dict = pyradDict)
try:
	req = srv.CreateAuthPacket(code = pyrad.packet.AccessRequest,
			User_Name = login)
except KeyError, e:
	do_loginfailure(configData,
			reason = 'Configuration error: The "dictionary" seems to be missing '
				'a definition required for operation.  Please try the dictionary '
				'from the "pyrad" distribution as documented in the rcweb README.  '
				'More information: "%s"' % str(e),
			login = login, password = password)
req['Service-Type'] = 'Login-User'
req['NAS-Identifier'] = os.uname()[1]
req['User-Password'] = req.PwCrypt(password)
try:
	reply = srv.SendPacket(req)
except pyrad.client.Timeout:
	do_loginfailure(configData, reason = 'No reply received from RADIUS server.',
			login = login, password = password)
except socket.error, error:
	do_loginfailure(configData,
			reason = 'Network error contacting RADIUS server: "%s"'
			% str(error[1]), login = login, password = password)
if reply.code != pyrad.packet.AccessAccept:
	do_loginfailure(configData, reason = 'Invalid login or bad password.',
			login = login, password = password)

#  load data
mode = 'current'
bodyFile = configData.get('datadircurrent')
if form.has_key('mode') and form['mode'].value == 'previous':
	mode = 'previous'
	bodyFile = configData.get('datadirprevious')
splitnum = configData.get('splitnum')
if splitnum: bodyFile = os.path.join(bodyFile, login[:splitnum])
bodyFile = os.path.join(bodyFile, login + '.html')
if os.path.exists(bodyFile):
	body = open(bodyFile).read()
else:
	body = 'No results found for user "%s"' % login

#  display results
do_results(configData, mode, body, login, password)
